
-----------------------------------------------------------------------------
-- TURBINE_PERMISSION
-----------------------------------------------------------------------------
drop table TURBINE_PERMISSION if exists;

CREATE TABLE TURBINE_PERMISSION
(
            PERMISSION_ID integer,
            PERMISSION_NAME VARCHAR (64),
    PRIMARY KEY(PERMISSION_ID),
    UNIQUE (PERMISSION_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_ROLE
-----------------------------------------------------------------------------
drop table TURBINE_ROLE if exists;

CREATE TABLE TURBINE_ROLE
(
            ROLE_ID integer,
            ROLE_NAME VARCHAR (64),
    PRIMARY KEY(ROLE_ID),
    UNIQUE (ROLE_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_GROUP
-----------------------------------------------------------------------------
drop table TURBINE_GROUP if exists;

CREATE TABLE TURBINE_GROUP
(
            GROUP_ID integer,
            GROUP_NAME VARCHAR (64),
    PRIMARY KEY(GROUP_ID),
    UNIQUE (GROUP_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_ROLE_PERMISSION
-----------------------------------------------------------------------------
drop table TURBINE_ROLE_PERMISSION if exists;

CREATE TABLE TURBINE_ROLE_PERMISSION
(
            ROLE_ID integer,
            PERMISSION_ID integer,
    PRIMARY KEY(ROLE_ID,PERMISSION_ID)
);


-----------------------------------------------------------------------------
-- TURBINE_USER
-----------------------------------------------------------------------------
drop table TURBINE_USER if exists;

CREATE TABLE TURBINE_USER
(
            USER_ID integer,
            LOGIN_NAME VARCHAR (64),
            PASSWORD_VALUE VARCHAR (16),
            FIRST_NAME VARCHAR (64),
            LAST_NAME VARCHAR (64),
            EMAIL VARCHAR (64),
            CONFIRM_VALUE VARCHAR (16),
            MODIFIED timestamp,
            CREATED timestamp,
            LAST_LOGIN timestamp,
            OBJECTDATA BINARY,
    PRIMARY KEY(USER_ID),
    UNIQUE (LOGIN_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_USER_GROUP_ROLE
-----------------------------------------------------------------------------
drop table TURBINE_USER_GROUP_ROLE if exists;

CREATE TABLE TURBINE_USER_GROUP_ROLE
(
            USER_ID integer,
            GROUP_ID integer,
            ROLE_ID integer,
    PRIMARY KEY(USER_ID,GROUP_ID,ROLE_ID)
);







    ALTER TABLE TURBINE_ROLE_PERMISSION
        ADD CONSTRAINT TURBINE_ROLE_PERMISSION_FK_1 FOREIGN KEY (ROLE_ID)
            REFERENCES TURBINE_ROLE (ROLE_ID)
;
    ALTER TABLE TURBINE_ROLE_PERMISSION
        ADD CONSTRAINT TURBINE_ROLE_PERMISSION_FK_2 FOREIGN KEY (PERMISSION_ID)
            REFERENCES TURBINE_PERMISSION (PERMISSION_ID)
;




    ALTER TABLE TURBINE_USER_GROUP_ROLE
        ADD CONSTRAINT TURBINE_USER_GROUP_ROLE_FK_1 FOREIGN KEY (USER_ID)
            REFERENCES TURBINE_USER (USER_ID)
;
    ALTER TABLE TURBINE_USER_GROUP_ROLE
        ADD CONSTRAINT TURBINE_USER_GROUP_ROLE_FK_2 FOREIGN KEY (GROUP_ID)
            REFERENCES TURBINE_GROUP (GROUP_ID)
;
    ALTER TABLE TURBINE_USER_GROUP_ROLE
        ADD CONSTRAINT TURBINE_USER_GROUP_ROLE_FK_3 FOREIGN KEY (ROLE_ID)
            REFERENCES TURBINE_ROLE (ROLE_ID)
;


