
-----------------------------------------------------------------------------
-- ID_TABLE
-----------------------------------------------------------------------------
DECLARE
    TABLE_DOES_NOT_EXIST EXCEPTION;
    PRAGMA EXCEPTION_INIT(TABLE_DOES_NOT_EXIST, -942);
BEGIN
    EXECUTE IMMEDIATE 'DROP TABLE ID_TABLE CASCADE CONSTRAINTS';
EXCEPTION
    WHEN TABLE_DOES_NOT_EXIST THEN NULL;
END;
/

CREATE TABLE ID_TABLE
(
    ID_TABLE_ID NUMBER NOT NULL,
    TABLE_NAME VARCHAR2 (255) NOT NULL,
    NEXT_ID NUMBER,
    QUANTITY NUMBER,
    CONSTRAINT ID_TABLE_U_1 UNIQUE (TABLE_NAME)
)
/

ALTER TABLE ID_TABLE
    ADD CONSTRAINT ID_TABLE_PK
PRIMARY KEY (ID_TABLE_ID)
/




