
-----------------------------------------------------------------------------
-- TURBINE_PERMISSION
-----------------------------------------------------------------------------
DROP TABLE TURBINE_PERMISSION CASCADE;


CREATE TABLE TURBINE_PERMISSION
(
                                    PERMISSION_ID integer NOT NULL,
                                    PERMISSION_NAME varchar (64) NOT NULL,
    PRIMARY KEY (PERMISSION_ID),
    CONSTRAINT TURBINE_PERMISSION_U_1 UNIQUE (PERMISSION_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_ROLE
-----------------------------------------------------------------------------
DROP TABLE TURBINE_ROLE CASCADE;


CREATE TABLE TURBINE_ROLE
(
                                    ROLE_ID integer NOT NULL,
                                    ROLE_NAME varchar (64) NOT NULL,
    PRIMARY KEY (ROLE_ID),
    CONSTRAINT TURBINE_ROLE_U_1 UNIQUE (ROLE_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_GROUP
-----------------------------------------------------------------------------
DROP TABLE TURBINE_GROUP CASCADE;


CREATE TABLE TURBINE_GROUP
(
                                    GROUP_ID integer NOT NULL,
                                    GROUP_NAME varchar (64) NOT NULL,
    PRIMARY KEY (GROUP_ID),
    CONSTRAINT TURBINE_GROUP_U_1 UNIQUE (GROUP_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_ROLE_PERMISSION
-----------------------------------------------------------------------------
DROP TABLE TURBINE_ROLE_PERMISSION CASCADE;


CREATE TABLE TURBINE_ROLE_PERMISSION
(
                                      -- REFERENCES TURBINE_ROLE (ROLE_ID)
    ROLE_ID integer NOT NULL,
                                      -- REFERENCES TURBINE_PERMISSION (PERMISSION_ID)
    PERMISSION_ID integer NOT NULL,
    PRIMARY KEY (ROLE_ID,PERMISSION_ID)
);


-----------------------------------------------------------------------------
-- TURBINE_USER
-----------------------------------------------------------------------------
DROP TABLE TURBINE_USER CASCADE;


CREATE TABLE TURBINE_USER
(
                                    USER_ID integer NOT NULL,
                                    LOGIN_NAME varchar (64) NOT NULL,
                                    PASSWORD_VALUE varchar (16) NOT NULL,
                                    FIRST_NAME varchar (64) NOT NULL,
                                    LAST_NAME varchar (64) NOT NULL,
                                    EMAIL varchar (64),
                                    CONFIRM_VALUE varchar (16),
                                    MODIFIED timestamp,
                                    CREATED timestamp,
                                    LAST_LOGIN timestamp,
                                    OBJECTDATA bytea,
    PRIMARY KEY (USER_ID),
    CONSTRAINT TURBINE_USER_U_1 UNIQUE (LOGIN_NAME)
);


-----------------------------------------------------------------------------
-- TURBINE_USER_GROUP_ROLE
-----------------------------------------------------------------------------
DROP TABLE TURBINE_USER_GROUP_ROLE CASCADE;


CREATE TABLE TURBINE_USER_GROUP_ROLE
(
                                      -- REFERENCES TURBINE_USER (USER_ID)
    USER_ID integer NOT NULL,
                                      -- REFERENCES TURBINE_GROUP (GROUP_ID)
    GROUP_ID integer NOT NULL,
                                      -- REFERENCES TURBINE_ROLE (ROLE_ID)
    ROLE_ID integer NOT NULL,
    PRIMARY KEY (USER_ID,GROUP_ID,ROLE_ID)
);


----------------------------------------------------------------------
-- TURBINE_USER_GROUP_ROLE                                                      
----------------------------------------------------------------------


----------------------------------------------------------------------
-- TURBINE_PERMISSION                                                      
----------------------------------------------------------------------


----------------------------------------------------------------------
-- TURBINE_ROLE                                                      
----------------------------------------------------------------------


----------------------------------------------------------------------
-- TURBINE_GROUP                                                      
----------------------------------------------------------------------

ALTER TABLE TURBINE_ROLE_PERMISSION
    ADD CONSTRAINT TURBINE_ROLE_PERMISSION_FK_1 FOREIGN KEY (ROLE_ID)
    REFERENCES TURBINE_ROLE (ROLE_ID)
;
ALTER TABLE TURBINE_ROLE_PERMISSION
    ADD CONSTRAINT TURBINE_ROLE_PERMISSION_FK_2 FOREIGN KEY (PERMISSION_ID)
    REFERENCES TURBINE_PERMISSION (PERMISSION_ID)
;

----------------------------------------------------------------------
-- TURBINE_ROLE_PERMISSION                                                      
----------------------------------------------------------------------


----------------------------------------------------------------------
-- TURBINE_USER                                                      
----------------------------------------------------------------------

ALTER TABLE TURBINE_USER_GROUP_ROLE
    ADD CONSTRAINT TURBINE_USER_GROUP_ROLE_FK_1 FOREIGN KEY (USER_ID)
    REFERENCES TURBINE_USER (USER_ID)
;
ALTER TABLE TURBINE_USER_GROUP_ROLE
    ADD CONSTRAINT TURBINE_USER_GROUP_ROLE_FK_2 FOREIGN KEY (GROUP_ID)
    REFERENCES TURBINE_GROUP (GROUP_ID)
;
ALTER TABLE TURBINE_USER_GROUP_ROLE
    ADD CONSTRAINT TURBINE_USER_GROUP_ROLE_FK_3 FOREIGN KEY (ROLE_ID)
    REFERENCES TURBINE_ROLE (ROLE_ID)
;
